import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
theorem nat.sym_eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((case_S) (n))) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
noncomputable def nat.pred_ : (nat.nat) -> nat.nat := fun (n : nat.nat) , ((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n).
theorem nat.pred_Sn : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) (((nat.pred_) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n)) (fun (y : nat.nat) , (((logic.eq_) (nat.nat)) (n)) (y))) (((@logic.refl_) (nat.nat)) (n)).
theorem nat.not_eq_S : forall (n:nat.nat) , forall (m:nat.nat) , (((connectives.Not) ) ((((logic.eq_) (nat.nat)) (n)) (m))) -> ((connectives.Not) ) ((((logic.eq_) (nat.nat)) (((nat.S) ) (n))) (((nat.S) ) (m))) := fun (n : nat.nat) , fun (m : nat.nat) , fun (auto : ((connectives.Not) ) ((((logic.eq_) (nat.nat)) (n)) (m))) , (((((@logic.not_to_not) ((((logic.eq_) (nat.nat)) (((nat.S) ) (n))) (((nat.S) ) (m)))) ((((logic.eq_) (nat.nat)) (n)) (m))) (fun (auto' : (((logic.eq_) (nat.nat)) (((nat.S) ) (n))) (((nat.S) ) (m))) , (((((((@logic.rewrite_l) (nat.nat)) (m)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (m))) (((@logic.refl_) (nat.nat)) (m))) (n)) (((((((@logic.rewrite_r) (nat.nat)) (((nat.pred_) ) (((nat.S) ) (n)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (m)) (__))) (((((((@logic.rewrite_r) (nat.nat)) (((nat.S) ) (m))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (m)) (((nat.pred_) ) (__)))) ((@nat.pred_Sn) (m))) (((nat.S) ) (n))) (auto'))) (n)) ((@nat.pred_Sn) (n)))))) (auto)).
